Global $fileopen
Global $fileread
Global $filelist
Global $bigfile
Global $bigfilename
Global $count = 0
Global $check = 0
Global $erroropen
Global $errorreport

Global $firstsplit
Global $secondsplit
Global $thirdsplit

Global $firstreplace
Global $secondreplace
Global $thirdreplace

MsgBox (0, "ProZGlosMerge v0.2", "Merges glossary HTML files from ProZ.com.  Put the script in the same folder as the files to be merged.  The script merges all files in all subdirectories also.", 0)

$filetype = InputBox ("What is the file extension?", "What is the file extension your downloader gave the HTML files... 'HTML' or 'HTM' or something else?", "HTM")

$filelist =  _GetFilesFolder_Rekursiv(@ScriptDir, $filetype, 0, 0)

$bigfilename = FileSaveDialog ("Save merged files into which file?", @ScriptDir, "All (*.*)|HTML files (*.html)", "", "allfiles.html")
$errorreport = FileSaveDialog ("Where to save the error report?", @ScriptDir, "All (*.*)|TXT files (*.txt)", "", "errorreport.txt")

$bigfile = FileOpen ($bigfilename, 129)
FileWrite ($bigfile, "<html><table>")
FileClose ($bigfile)

For $i = 1 to $filelist[0]

$fileopen = FileOpen ($filelist[$i], 128)
$fileread = FileRead ($fileopen)

; First get rid of top and bottom matter

$firstsplit = StringSplit ($fileread, "Glossary name</td></tr>", 1)
If $firstsplit[0] <> 2 Then
$erroropen = FileOpen ($errorreport, 129)
FileWrite ($erroropen, "Error at first split: " & $filelist[$i] & @CRLF)
FileClose ($erroropen)
ContinueLoop
EndIf

$secondsplit = StringSplit ($firstsplit[2], "<strong>", 1)
If $secondsplit[0] <> 2 Then
$erroropen = FileOpen ($errorreport, 129)
FileWrite ($erroropen, "Error at second split: " & $filelist[$i] & @CRLF)
FileClose ($erroropen)
ContinueLoop
EndIf

$thirdsplit = StringSplit ($secondsplit[1], "</table><center>", 1)
If $thirdsplit[0] <> 2 Then
$erroropen = FileOpen ($errorreport, 129)
FileWrite ($erroropen, "Error at third split: " & $filelist[$i] & @CRLF)
FileClose ($erroropen)
ContinueLoop
EndIf

; Then get rid of IMG and anchors

$firstreplace = StringRegExpReplace ($thirdsplit[1], "<img.+?>", "")
$secondreplace = StringRegExpReplace ($firstreplace, "<a.+?>", "")
$thirdreplace = StringReplace ($secondreplace, "</a>", "")

$bigfile = FileOpen ($bigfilename, 129)
FileWrite ($bigfile, $thirdreplace)
FileClose ($bigfile)

$count = $count + 1

Next

$bigfile = FileOpen ($bigfilename, 129)
FileWrite ($bigfile, "</table></html>")
FileClose ($bigfile)

MsgBox (0, "Done...", "Did " & $count & " files.", 0)






;======================================================================================
; Function Name:   _GetFilesFolder_Rekursiv($sPath [, $sExt='*' [, $iDir=-1 [, $iRetType=0 ,[$sDelim='0']]]])
; Description:     recursive listing of files and/or folders
; Parameter(s):    $sPath     Basicpath of listing ('.' -current path, '..' -parent path)
;                  $sExt      Extension for file selection '*' or -1 for all (Default)
;                  $iDir      -1 files+Folder(Default), 0 only files, 1 only Folder
;      optional:   $iRetType  0 for Array, 1 for String as Return
;      optional:   $sDelim    Delimiter for string return
;                             0 -@CRLF (Default)  1 -@CR  2 -@LF  3 -';'  4 -'|'
; Return Value(s): Array (Default) or string with found pathes of files and/or folder
;                  Array[0] includes count of found files/folder
; Author(s):       BugFix (bugfix@autoit.de)
;=====================================================================================

Func _GetFilesFolder_Rekursiv($sPath, $sExt='*', $iDir=-1, $iRetType=0, $sDelim='0')
    Global $oFSO = ObjCreate('Scripting.FileSystemObject')
    Global $strFiles = ''
    Switch $sDelim
        Case '1'
            $sDelim = @CR
        Case '2'
            $sDelim = @LF
        Case '3'
            $sDelim = ';'
        Case '4'
            $sDelim = '|'
        Case Else
            $sDelim = @CRLF
    EndSwitch
    If ($iRetType < 0) Or ($iRetType > 1) Then $iRetType = 0
    If $sExt = -1 Then $sExt = '*'
    If ($iDir < -1) Or ($iDir > 1) Then $iDir = -1
    _ShowSubFolders($oFSO.GetFolder($sPath),$sExt,$iDir,$sDelim)
    If $iRetType = 0 Then
        Local $aOut
        $aOut = StringSplit(StringTrimRight($strFiles, StringLen($sDelim)), $sDelim, 1)
        If $aOut[1] = '' Then
            ReDim $aOut[1]
            $aOut[0] = 0
        EndIf
        Return $aOut
    Else
        Return StringTrimRight($strFiles, StringLen($sDelim))
    EndIf
EndFunc

Func _ShowSubFolders($Folder, $Ext='*', $Dir=-1, $Delim=@CRLF)
    If Not IsDeclared("strFiles") Then Global $strFiles = ''
    If ($Dir = -1) Or ($Dir = 0) Then
        For $file In $Folder.Files
            If $Ext <> '*' Then
                If StringRight($file.Name, StringLen($Ext)) = $Ext Then _
                    $strFiles &= $file.Path & $Delim
            Else
                $strFiles &= $file.Path & $Delim
            EndIf
        Next
    EndIf
    For $Subfolder In $Folder.SubFolders
        If ($Dir = -1) Or ($Dir = 1) Then $strFiles &= $Subfolder.Path & '\' & $Delim
        _ShowSubFolders($Subfolder, $Ext, $Dir, $Delim)
    Next
EndFunc
 